---
title: FormData()
slug: Web/API/FormData/FormData
tags:
  - API
  - Constructor
  - FormData
  - Reference
  - XHR
  - XMLHttpRequest
---
<p>{{APIRef("XMLHttpRequest")}}</p>

<p>The <code><strong>FormData()</strong></code> constructor creates a new {{domxref("FormData")}} object.</p>

<div class="note">
<p><strong>Note</strong>: This feature is available in <a href="/en-US/docs/Web/API/Web_Workers_API">Web Workers</a>.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="brush: js"><code>var formData = new FormData(</code><code>form</code><code>)</code></pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>form </code>{{optional_inline}}</dt>
 <dd>An HTML {{HTMLElement("form")}} element — when specified, the {{domxref("FormData")}} object will be populated with the form's current keys/values using the name property of each element for the keys and their submitted value for the values. It will also encode file input content.</dd>
</dl>

<h2 id="Example">Example</h2>

<p>The following line creates an empty <code>FormData</code> object:</p>

<pre class="brush: js">var formData = new FormData(); // Currently empty</pre>

<p>You could add a key/value pair to this using {{domxref("FormData.append")}}:</p>

<pre class="brush: js">formData.append('username', 'Chris');
</pre>

<p>Or you can specify the optional <code><em>form</em></code> argument when creating the <code>FormData</code> object, to prepopulate it with values from the specified form:</p>

<pre class="brush: html">&lt;form id="myForm" name="myForm"&gt;
  &lt;div&gt;
    &lt;label for="username"&gt;Enter name:&lt;/label&gt;
    &lt;input type="text" id="username" name="username"&gt;
  &lt;/div&gt;
  &lt;div&gt;
    &lt;label for="useracc"&gt;Enter account number:&lt;/label&gt;
    &lt;input type="text" id="useracc" name="useracc"&gt;
  &lt;/div&gt;
  &lt;div&gt;
    &lt;label for="userfile"&gt;Upload file:&lt;/label&gt;
    &lt;input type="file" id="userfile" name="userfile"&gt;
  &lt;/div&gt;
  &lt;input type="submit" value="Submit!"&gt;
&lt;/form&gt;
</pre>

<div class="note">
<p><strong>Note</strong>: Only successful form controls are included in a FormData object, i.e. those with a name, not disabled and checked (radio buttons and checkboxes) or selected (one or more options within a select).</p>
</div>

<pre class="brush: js">let myForm = document.getElementById('myForm');
let formData = new FormData(myForm);</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('XMLHttpRequest','#dom-formdata','FormData()')}}</td>
   <td>{{Spec2('XMLHttpRequest')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.FormData.FormData")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("XMLHTTPRequest")}}</li>
 <li><a href="/en-US/docs/DOM/XMLHttpRequest/Using_XMLHttpRequest" title="Using XMLHttpRequest">Using XMLHttpRequest</a></li>
 <li><a href="/en-US/docs/DOM/XMLHttpRequest/FormData/Using_FormData_Objects" title="DOM/XMLHttpRequest/FormData/Using_FormData_objects">Using FormData objects</a></li>
 <li>{{HTMLElement("Form")}}</li>
</ul>
